local L = AceLibrary("AceLocale-2.2"):new("BigWigs_TotemRange")
local P = AceLibrary("Pastmaster-1.0")

L:RegisterTranslations("enUS", function() return {
  gain = "Gained '%s' Buff", lose = "Lost '%s' Buff",
  Totem = true, Toggle = true, Broadcast = true,
  totemdesc = "Alerts for when in/out of range of totem buffs.",
  toggledesc = "Toggles the plugin on/off.",
  broadcastdesc = "Toggle broadcasting."
} end)

BigWigs_TotemRange = BigWigs:NewModule("TotemRange")
BigWigs_TotemRange.defaultDB = {on = true}

local totems = {
  ["Stoneskin"] = false,
  ["Strength of Earth"] = false,
  ["Tremor"] = false,
  ["Frost Resistance"] = false,
  ["Totem of Wrath"] = false,
  ["Grace of Air"] = false,
  ["Grounding"] = false,
  ["Nature Resistance"] = false,
  ["Windfury"] = false,
  ["Windwall"] = false,
  ["Disease Cleansing"] = false,
  ["Enamored Water Spirit"] = false,
  ["Fire Resistance"] = false,
  ["Healing Stream"] = false,
  ["Mana Spring"] = false,
  ["Mana Tide"] = false,
  ["Poison Cleansing"] = false,
}

BigWigs_TotemRange.consoleCmd = L.Totem
BigWigs_TotemRange.consoleOptions = {
	type = "group",
	name = L.Totem,
	desc = L.totemdesc,
	args   = {
		[L.Toggle] = {
			type = "toggle",
			name = L.Toggle,
			desc = L.toggledesc,
			get = function() return BigWigs_TotemRange:IsEventRegistered("PLAYER_AURAS_CHANGED") end,
			set = function(v)
				BigWigs_TotemRange.db.profile.on = v
				local event = "PLAYER_AURAS_CHANGED"
				if v then
				  BigWigs_TotemRange:RegisterEvent(evt)
				else
				  BigWigs_TotemRange:UnregisterEvent(evt)
				end
			end,
		},
		[L.Broadcast] = {
			type = "toggle",
			name = L.Broadcast,
			desc = L.broadcastdesc,
			get = function() return BigWigs_TotemRange.db.profile.broadcast end,
			set = function(v) BigWigs_TotemRange.db.profile.broadcast = v end,
		}
	}
}

function BigWigs_TotemRange:OnEnable()
  self:RegisterEvent("PLAYER_AURAS_CHANGED", function()
    for k, v in pairs(totems) do
      local check = P:buffcheck(k)
      if check and v == false then
        self:TriggerEvent("BigWigs_Message", format(L.gain, k), "Orange", not self.db.profile.broadcast)
        totems[k] = true
      elseif not check and v == true then
        self:TriggerEvent("BigWigs_Message", format(L.lose, k), "Orange", not self.db.profile.broadcast)
        totems[k] = false
      end
    end
  end)
end